package cn.gov.customs.wxjy.base.service.impl;

import cn.gov.customs.cacp.sdks.core.user.trans.CacpTransUser;
import cn.gov.customs.wxjy.common.exception.ServiceException;
import cn.gov.customs.wxjy.common.utils.StringUtils;
import cn.gov.customs.wxjy.common.utils.bean.BeanValidators;
import cn.gov.customs.wxjy.common.utils.uuid.SnowflakeIdWorker;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import javax.validation.Validator;
import java.util.List;
import org.apache.commons.collections4.CollectionUtils;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import com.github.pagehelper.PageInfo;
import cn.gov.customs.wxjy.common.utils.DateUtils;
import cn.gov.customs.wxjy.base.dao.PackCatalogMapper;
import cn.gov.customs.wxjy.base.pojo.PackCatalog;
import cn.gov.customs.wxjy.base.pojo.PackCatalogQuery;
import cn.gov.customs.wxjy.base.service.IPackCatalogService;

/**
 * 包装种类目录Service业务层处理
 *
 * @author xiong
 * @date 2025-12-16
 */
@Service
@Slf4j
@RequiredArgsConstructor
public class PackCatalogServiceImpl implements IPackCatalogService {

    private final PackCatalogMapper packCatalogMapper;

    private final Validator validator;

    /**
     * 查询包装种类目录
     *
     * @param ID 包装种类目录主键
     * @return 包装种类目录
     */
    @Override
    public PackCatalog selectByID(String ID) {
        return packCatalogMapper.selectByID(ID);
    }

    /**
     * 分页查询包装种类目录列表
     *
     * @param query
     * @return 包装种类目录
     */
    @Override
    public PageInfo<PackCatalog> selectPageList(PackCatalogQuery query) {
        return PageInfo.of(packCatalogMapper.selectList(query));
    }

    /**
     * 查询包装种类目录列表
     *
     * @param query
     * @return 包装种类目录
     */
    @Override
    public List<PackCatalog> selectList(PackCatalogQuery query) {
        return packCatalogMapper.selectList(query);
    }

    /**
     * 新增包装种类目录
     *
     * @param packCatalog 包装种类目录
     * @return 结果
     */
    @Override
    public int insert(PackCatalog packCatalog) {
            return packCatalogMapper.insert(packCatalog);
    }

    /**
     * 修改包装种类目录
     *
     * @param packCatalog 包装种类目录
     * @return 结果
     */
    @Override
    public int update(PackCatalog packCatalog) {
        return packCatalogMapper.update(packCatalog);
    }

    /**
     * 批量删除包装种类目录
     *
     * @param ids 需要删除的包装种类目录主键
     * @return 结果
     */
    @Override
    public int deleteByIDs(String[] ids) {
        return packCatalogMapper.deleteByIDs(ids);
    }

    /**
     * 删除包装种类目录信息
     *
     * @param ID 包装种类目录主键
     * @return 结果
     */
    @Override
    public int deleteByID(String ID) {
        return packCatalogMapper.deleteByID(ID);
    }

    /**
     * 逻辑删除包装种类目录信息
     *
     * @param ID 包装种类目录主键
     * @return 结果
     */
    @Override
    public int logicDelete(String ID) {

        return packCatalogMapper.logicDelete(ID);
    }

    /**
     * 导入包装种类目录数据
     *
     * @param packCatalogList 包装种类目录数据列表
     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
     * @param cacpTransUser 操作用户
     * @return 结果
     */
    @Override
    public String importPackCatalog(List<PackCatalog> packCatalogList, Boolean isUpdateSupport, CacpTransUser cacpTransUser) {
        if (CollectionUtils.isEmpty(packCatalogList)) {
            throw new ServiceException("导入数据不能为空！");
        }
        int successNum = 0;
        int failureNum = 0;
        StringBuilder successMsg = new StringBuilder();
        StringBuilder failureMsg = new StringBuilder();
        for (PackCatalog packCatalog : packCatalogList) {
            try {

                BeanValidators.validateWithException(validator, packCatalog);
                //id名称不统一，自行处理
                packCatalog.setCreateTime(DateUtils.getNowDate());
                packCatalog.setUpdateTime(DateUtils.getNowDate());
                packCatalog.setCreateUser(cacpTransUser.getUserId());
                packCatalog.setCreateDept(cacpTransUser.getParentGuid());

                packCatalogMapper.insert(packCatalog);
                successNum++;
                successMsg.append("<br/>" + successNum + "、 " + cacpTransUser.getUserName() + " 导入成功");

            } catch (Exception e) {
                failureNum++;
                String msg = "<br/>" + failureNum + "、" + cacpTransUser.getUserName() + " 导入失败：";
                failureMsg.append(msg + e.getMessage());
                log.error(msg, e);
            }
        }
        if (failureNum > 0) {
            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
            throw new ServiceException(failureMsg.toString());
        } else {
            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
        }
        return successMsg.toString();
    }
}
